#!/usr/bin/guile-3.0 \
-e __main -s
!#

;; Copyright (C) 2018 Tommi Höynälänmaa
;; Distributed under GNU Lesser General Public License version 3,
;; see file doc/LGPL-3.

(eval-when
 (expand load eval)

 (import (except (rnrs) assert map))
 (import (theme-d runtime runtime-theme-d-environment))
 (import (th-scheme-utilities parse-command-line))
 (import (th-scheme-utilities stdutils))
 (import (th-scheme-utilities hrecord))

 (define gl-proper-args '())
 (define verbose-errors? #t)
 (define backtrace? #f)
 (define pretty-backtrace? #f)
 (define show-version? #f)
 
 (let* ((argd1 (make-hrecord <argument-descriptor> "no-verbose-errors" #f
			     (lambda () (set! verbose-errors? #f))))
	(argd2 (make-hrecord <argument-descriptor> "backtrace" #f
			     (lambda () (set! backtrace? #t))))
	(argd3 (make-hrecord <argument-descriptor> "pretty-backtrace" #f
			     (lambda () (set! pretty-backtrace? #t))))
	(argd4 (make-hrecord <argument-descriptor> "version" #f
			     (lambda () (set! show-version? #t))))
	(args-without-cmd (cdr (command-line)))
	(arg-descs (list argd1 argd2 argd3 argd4))
	(proper-args '())
	(handle-proper-args (lambda (proper-args1)
			      (set! proper-args proper-args1))))
   (parse-command-line args-without-cmd arg-descs handle-proper-args)
   (set! gl-proper-args proper-args)
   (theme-set-command-line! proper-args))

 (if (not-null? gl-proper-args)
     (let ((str-new-dir (car gl-proper-args)))
       (set! %load-compiled-path (cons str-new-dir %load-compiled-path)))))

(if show-version?
    (begin
      (display "5.0.0")
      (newline)
      (exit 0)))
(if (null? gl-proper-args)
    (begin
      (display "No program name given.\n")
      (exit 1)))

(import (target-main))


(define (__main args)
    (if (not gl-script?)
	(begin
	  (set-verbose-errors! verbose-errors?)
	  (set-backtrace! backtrace?)
	  (set-pretty-backtrace! pretty-backtrace?)
	  (set-rte-exception-info! #t)
	  (main gl-proper-args))))
